#!/bin/sh
# 
# change the variable waspii to any value like at your own risk.
# we like the name and install directory of this program to be "waspii"
# and we do not encourage you to change it.
# The scripts haven't been tested with a different value for waspii
#
waspii="waspii"

echo ""
echo ""
echo -n "Where is your PERL? [/usr/bin/perl]:"
read PERL
if [ "$PERL" = "" ]
  then
   PERL="/usr/bin/perl"
fi
if  test -f $PERL -a -x $PERL 
   then
   echo "perl ok..."
else
   echo ""
   echo "No!. Either PERL is not there or not executable!"
   echo "Script aborted..."
   exit
fi

echo ""
echo ""
echo "What is the fully qualified domain name of this WASPII host?"
echo "Please make sure that this host is a web server."
echo "You should enter something like listserver.domain.edu"
name1=`hostname`
name2=`hostname -d`
name="$name1.$name2"
VALID=false
until $VALID
do
    echo -n "Hostname [$name] : "
    read httphost
    if [ "$httphost" = "" ]
      then
       httphost=$name
    fi
    #
 # we expect at least one dot embedded between some text
    if expr "$httphost" : ".*\..*" >/dev/null
 then
 VALID=true
 else
 echo "Invalid host name. Try again"
 echo ""
    fi
done

echo ""
echo ""
echo -n "Where is your http document root? [/home/httpd/html]: "
read docroot
if [ "$docroot" = "" ]
   then
     docroot="/home/httpd/html"
fi

/bin/mkdir $docroot/remove_me 2> /dev/null
if [ "$?" = 1 ]
 then 
     echo ""
     echo "Cannot create a directory there.."
     echo "Either there is no such directory or there is a permission problem."
     echo "Script aborted!"
     exit
fi
/bin/rm -r $docroot/remove_me 2> /dev/null
echo ""
echo ""
echo "What is the full path to the cgi-bin directory of your server?"
echo "You should enter something like /home/httpd/cgi-bin"
VALID=false
until $VALID
do
    echo -n "cgi-bin path [/home/httpd/cgi-bin] : "
    read cgi_root
    if [ "$cgi_root" = "" ]
       then
         cgi_root="/home/httpd/cgi-bin"
    fi
    if [ -d $cgi_root ]  >/dev/null
      then
       VALID=true
      else
       echo "Could not find $cgi_root. Try again"
       echo ""
    fi
done

/bin/mkdir $cgi_root/remove_me 2> /dev/null
if [ "$?" = 1 ]
 then 
     echo ""
     echo "Cannot create a directory there.."
     echo "Either there is no such directory or there is a permission problem"
     echo "Script aborted!"
     exit
fi
/bin/rm -r $cgi_root/remove_me 2> /dev/null

echo ""
echo ""
echo "================================================================="
echo "Will install files to $docroot/$waspii and $cgi_root/$waspii"
echo "If this is not what you want, abort the script NOW!"
echo "================================================================="
echo ""
echo ""
echo "What is the cgi-bin name that one must append to your web server main URL?
"
echo -n "cgi-bin name relative to main URL [cgi-bin] : "
read relative_cgi
if [ "$relative_cgi" = "" ]
      then
        relative_cgi="cgi-bin"
fi

echo ""
echo ""
echo -n "What is the userID for your httpd daemon? [nobody]:"
read httpuser
if ["$httpuser" = ""]
   then
   httpuser="nobody"
fi

/bin/mkdir $docroot/$waspii 2> /dev/null
/bin/cp -r ./waspii-html/* $docroot/$waspii
/bin/mkdir $cgi_root/$waspii  2> /dev/null
/bin/cp -r ./waspii-cgi/* $cgi_root/$waspii
#echo "WASPII html and cgi files are copied to where they belong"
/bin/chown -R $httpuser:$httpuser $docroot/$waspii
/bin/chown -R $httpuser:$httpuser $cgi_root/$waspii
#
# replace all perl references in all cgi and pl files
#
#
# replace all perl references in all cgi and pl files
#
$PERL -p -i.bak -e "s#/usr/bin/perl#$PERL#" $cgi_root/$waspii/*.pl
$PERL -p -i.bak -e "s#/usr/bin/perl#$PERL#" $cgi_root/$waspii/*.cgi
$PERL -p -i.bak -e "s#/usr/bin/perl#$PERL#" $cgi_root/$waspii/TEMPLATE/*.cgi
$PERL -p -i.bak -e "s#/usr/bin/perl#$PERL#" $cgi_root/$waspii/TEMPLATE/*.pl
$PERL -p -i.bak -e "s#/usr/bin/perl#$PERL#" $cgi_root/$waspii/TEMPLATE/admin/*.pl
$PERL -p -i.bak -e "s#/usr/bin/perl#$PERL#" $cgi_root/$waspii/TEMPLATE/admin/*.cgi

HOSTIP=`hostname --ip-address 2>/dev/null`
#
# is the IP address in format nnn.nnn.nnn.nnn?
#
matchstring="[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}\.[0-9]\{1,3\}" 
if expr "$HOSTIP" : $matchstring >/dev/null
   then
   dummy=1
   else
    echo " "
    echo "Cannot extract your IP address! \"hostname --ip-address\" command"
    echo "did not return a meaninfull result."
    IPVALID=false
    until  $IPVALID 
    do 
         echo ""
         echo -n "Please enter your WASPII server IP address (nnn.nnn.nnn.nnn):"
         read HOSTIP
         if expr "$HOSTIP" : $matchstring > /dev/null
             then
             IPVALID=true
         fi
    done

fi
echo ""
echo ""
echo "If you will be administering WASPII from another computer,"
echo "you should enter that computer's IP number as a secondary"
echo "admin host. The IP number of your desktop should do."
echo "If you do not intend to do remote administration, you can"
echo "leave this secondary IP blank."
echo "You can add a comment after typing a #"
echo "Example: 139.179.10.46 # ayfers desktop
echo "If you type an incorrect IP number, administration will be a problem.
echo "You can later modify the file $cgi_root/$waspii/.hosts.admin"
echo "to add or remove admin hosts for this WASPII service."
echo  -n "Enter secondary admin host IP:"
read HOSTIP2

#echo " "
#echo "Creating $cgi_root/$waspii/.hosts.admin file for this IP."
#echo "This host will be the master administrator."
/bin/cat >  $cgi_root/$waspii/.hosts.admin <<EOM
$HOSTIP
$HOSTIP2
EOM
/bin/chown $httpuser:$httpuser  $cgi_root/$waspii/.hosts.admin
/bin/chmod 700  $cgi_root/$waspii/.hosts.admin


echo ""
echo ""
echo "What text do you want to appear on browser window title bars?"
echo -n "HTTP Meta Description text [Announcement Mailing Lists] : "
 read meta_desc
    if [ "$meta_desc" = "" ]
      then
       meta_desc="WASPII - Announcement Mailing Lists"   
    fi


echo ""
echo ""
echo "What text do you want to appear as the title on WASPII created web pages?"
echo -n "WEB Page title [WASPII Announcement System] : "
 read title
    if [ "$title" = "" ]
      then
      title="WASPII Announcement System" 
    fi

echo ""
echo ""
echo "What name do you want to appear as the sender on WASPII distributed mail?"
 echo -n "Sender name [WASPII Announcements] : "
 read yourname
 if ["$yourname" = ""]
    then
     yourname="WASPII Announcements"
 fi


echo ""
echo ""
echo "What is the e-mail address for the WASPII administrator?"
VALID=false
until $VALID
do
 echo -n "Admin e-mail address [listmaster@$httphost] : "
 read youremail
 if ["$youremail" = ""]
    then
      youremail="listmaster@$httphost"
 fi
 if expr "$youremail" : ".*@.*"  >/dev/null
    then
     VALID=true
    else
     echo "You must enter a valid e-mail addr"
     echo ""
 fi
done


echo ""
echo ""
echo "What program is responsible on your host for sending out SMTP mail?"
echo "Normally it will be \"/usr/lib/sendmail\""
VALID=false
until $VALID
do
 echo -n "Full path to your sendmail program [/usr/lib/sendmail] : "
 read mailprogram
 if ["$mailprogram" = ""]
     then
      mailprogram="/usr/lib/sendmail"
    fi
    if [ -f $mailprogram ]
      then
       VALID=true
      else
       echo "Cannot find $mailprogram! Try again."
       echo ""
    fi
done


echo ""
echo ""
echo "What program is used on your host to set/change .htaccess passwords?"
echo "(Refer to your http server documentation)"
echo "Normally it will be \"/usr/bin/htpasswd\""
VALID=false
until $VALID
do
 echo -n "Path to htpasswd program or equivalent [/usr/bin/htpasswd] : "
 read htpasswd
    if [ "$htpasswd" = "" ]
     then
      htpasswd="/usr/bin/htpasswd"
    fi
    if [ -f $htpasswd ]
      then
       VALID=true
      else
       echo "Cannot find $htpasswd! Try again."
       echo ""
    fi
done
#
# Make replacements in the config.pl file
#

$PERL -p -i.bak -e "s#\$httphost=\"hostname.dom\"#\$httphost=\"$httphost\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$cgi_root=\"/home/httpd/cgi-bin\"#\$cgi_root=\"$cgi_root\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$relative_cgi=\"cgi-bin\"#\$relative_cgi=\"$relative_cgi\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$http_root=\"/home/httpd/html\"#\$http_root=\"$docroot\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$meta_desc=\"Announcement Mailing Lists\"#\$meta_desc=\"$meta_desc\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$title=\"WASPII - Announcement System\"#\$title=\"$title\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$yourname=\"WASPII Announcements\"#\$yourname=\"$yourname\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$waspii_root=\"waspii\"#\$waspii_root=\"$waspii\"#" $cgi_root/$waspii/TEMPLATE/config.pl
#
# PERL requires @'s to be escaped
#
# I used temp files here because I couldn't fing a sh method
# to replace @'s with \\\@'s on shell vars
#
if [ -f /tmp/delete.me ]
  then
   /bin/rm /tmp/delete.me
fi
/bin/cat > /tmp/delete.me <<EOM
$youremail
EOM
#
# Use single quotes in the following sed command. Dbl quotes make sh go crazy,#
#
/bin/sed -e 's/\@/\\\\\\@/' /tmp/delete.me > /tmp/delete.me.too
youremail=`cat /tmp/delete.me.too`

#/bin/rm /tmp/delete.me /tmp/delete.me.too

$PERL -p -i.bak -e "s#\$youremail=\"listmaster\"#\$youremail=\"$youremail\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$mailprogram=\"/usr/lib/sendmail\"#\$mailprogram=\"$mailprogram\"#" $cgi_root/$waspii/TEMPLATE/config.pl
$PERL -p -i.bak -e "s#\$htpasswd=\"/usr/bin/htpasswd\"#\$htpasswd=\"$htpasswd\"#" $cgi_root/$waspii/TEMPLATE/config.pl

#
# change the cgi reference in creating2.htm in the waspii html dir
#
$PERL -p -i.bak -e "s#<form action=\"http://domain/cgi-bin/waspii/create\.cgi#<form action=\"http://$httphost/$relative_cgi/$waspii/create\.cgi#" $docroot/$waspii/creating2.htm

#
# change the auto refresh reference in lists.htm in the waspii html dir
#
$PERL -p -i.bak -e "s#http://domain/cgi-bin/waspii/main\.cgi#http://$httphost/$relative_cgi/$waspii/main\.cgi#" $docroot/$waspii/lists.htm

/bin/rm $docroot/*.bak
/bin/rm $cgi_root/*.bak
/bin/rm $cgi_root/TEMPLATE/*.bak
/bin/rm $cgi_root/TEMPLATE/admin/*.bak

echo ""
echo "Installation complete..."
echo ""
echo "Now point your browser to http://$httphost/$waspii/lists.htm to start your WASPII"
echo ""
echo "Enjoy..."
echo ""

