#!/usr/bin/perl -U
# ------------- 
# WASPII List Manager 
# ------------- 
# Email list manager 
# 
# File: admin.cgi 
# Description: Admin Interface 
# Security: Place in password protected directory 
# Author: Martin Kretzmann Enhanced by Can Ugur Ayfer
# Version: 3.0 
# 
# 
#==================================================================== 

# the path to config.pl on your server 
require '../config.pl'; 


require "../$subs_path"; 
&data_parse; 
#
#  Check IP based Authentication is selected
#  (User based admin auth is taken care by httpd/.htaccess scheme)
#
if ($auth eq "ip") {
   #
   #  check if user's IP is in this list
   #
   $user_is_admin = & check_admin(".hosts.admin");
   if ( $user_is_admin ne "yes" )  {
        die &error($errmsg="You are not allowed to administer this list!"); 
   }

}    # continue if IP is  authorized or IP authentication is not selected

&decide; 

#************************************************** 
# Decide what to do 
#************************************************** 

sub decide{ 
my $action = $FORM{'action'}; 
if ($action eq 'search'){ &search; } 
elsif ($action eq 'delete'){ &delete; } 
elsif ($action eq 'compose'){ &compose; } 
elsif ($action eq 'send'){ &send; } 
elsif ($action eq 'mailto') { &compose; } 
elsif ($action eq 'backup'){ &backup; } 
elsif ($action eq 'restore'){ &restore; } 
elsif ($action eq 'cleanup'){ &cleanup; } 
elsif ($action eq 'Batch Subscribe'){ &batch; }
elsif ($action eq 'List All'){ &listall; }
elsif ($action eq 'Delete All'){ &deleteall; }
else{ &main; } 
} 

#********************************************** 
# 
# Remove unconfirmed addresses from the database 
# after 15 days 
#********************************************** 

sub cleanup{ 

# get time 
&unix_to_time; 

# localise the variables 
my ($vid, $email, $td, $tm, $ty, $test, $this_number_of_days, $number_of_days); 

# number of days since the year zero 
$number_of_days = $year*365 + $DayOfYear; 

# open the confirm database 
dbmopen(%DB, "../$db_data_path/confirm", 0600) or die &error($errmsg="Unable to open $db_data_path/confirm"); 
my (@allkeys) = keys(%DB); 
&top("$list_name Admin - Cleaning up"); 
print "Cleaning up $db_data_path/confirm<br>"; 

# testing each entry 
foreach $key(@allkeys){ 
($vid, $email, $td, $tm, $ty) = split(/\t/, $DB{$key}); 

# days since the year zero until this entry was made 
$this_number_of_days = $ty*365 + $tm*30 + $td; 
$test = $number_of_days - $this_number_of_days; 
if ($test >= 15){ 
delete($DB{$key}); 
print "removing $email which hasn't been confirmed for $test days<br>"; 
} 
} 
dbmclose(%DB); 
print "<b>Done!</b><p>"; 
&sig; 
&bottom; 
} 


#******************************************** 
# 
# Back up the database 
# 
#******************************************** 

sub backup{ 
# open databases 
dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg = "Unable to open $db_data_path/emails Reason:$!"); 
dbmopen(%BDB, "../$db_data_path/emailsbackup", 0600) or die &error($errmsg = "Unabe to open $db_data_path/emailsbackup Reason:$!"); 
# perform the backup 
%BDB = %DB; 
dbmclose(%DB); 
dbmclose(%BDB); 
&top("$list_name Admin data backup"); 
print "The data base is successfully backed up"; 
&sig; 
&bottom; 
} 

#************************************ 
# 
# Restore from backup 
# 
#************************************ 

sub restore{ 
# open databases 
dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg = "Unable to open $db_data_path/emails Reason:$!"); 
dbmopen(%BDB, "../$db_data_path/emailsbackup", 0600) or die &error($errmsg = "Unable to open $db_data_path/emailsbackup Reason:$!"); 

# restoring 
%DB = %BDB; 
&top("$list_name Admin restore"); 
print "The database is successfully restored from backup"; 
&sig; 
&bottom; 
} 

#*********************************** 
# 
# Send the messages 
# 
#*********************************** 

sub send{ 

# not sent if no message body 
if ($FORM{'body'} eq '' || !$FORM{'body'}){ &error($errmsg = "Can't send empty message"); } 
my @to; 
my $output; 
my $header; 

# who do we send to? 
if ($FORM{'to'} ne 'all'){ 
# if not all, we send to the addresses given 
@to = split(/,\s+/, $FORM{'to'}); 
} else { 

# if all, we send to the entire list 
dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg="Unable to open $db_data_path/emails"); 
my (@allkeys) = keys(%DB); 
foreach $key (@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
push(@to, $email); 
} 
dbmclose(%DB); 
} 

# defining message body 
&top("Sending messages"); 
$header = "From: $yourname <$youremail>\n"; 
$header.= "Subject: $FORM{'subject'}\n"; 
$header.= "Precedence: Bulk\n"; 
$header.= "X-mailer: WASPII List Manager 3.0 \n"; 
$output = "----------------------------------------\n"; 
$output.= "$FORM{'body'}\n\n"; 
$output.= "To subscribe/unsubscribe $title lists go to:"; 
$footer = "----------------------------------------\n"; 

# send the messages 
print "Sending messages to:<br>"; 
#CUA push (@to, 'plebius@prontomail.com'); 

# Sleep 10 seconds after sending each 20 mails to avoid
# CPU congestion

$sendcount=0;
if ($mail_to_admin eq "yes") {
   @to = (@to, $youremail);
}

foreach $email (@to){ 
open(MAIL, "|$mailprogram -t"); 
print MAIL "$header"; 
print MAIL "To: $email\n"; 
print MAIL "$output\n"; 
print MAIL "http://$ENV{'HTTP_HOST'}/$waspii_root/lists.htm\n"; 
print MAIL "$footer\n"; 
close(MAIL); 
print "$email, "; 
$sendcount = $sendcount +1;
if ($sendcount > 19 ) {
   sleep 10;
   $sendcount = 0;
}
} 
print "<p><b>Done!!</b>"; 
print "The following message was sent:<p>"; 
print "<pre>$FORM{'body'}</pre>"; 
&sig; 
&bottom; 
} 


#*************************************************** 
# 
# compose a message to the list, or to what we're 
# given 
# 
#*************************************************** 

sub compose{ 
my (@to); 

# send to specific addresses 
if ($FORM{'action'} eq 'mailto'){ 
dbmopen(%DB, "../$db_data_path/emails", 0600); 
my (@allkeys) = keys(%DB); 
foreach $key (@allkeys){ 
if ($FORM{$key} eq 'mailto'){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
push(@to, $email); 
} 
} 
@to = join(", ", @to); 
dbmclose(%DB); 
} else { $to[0] = "all"; } # otherwise we send to the entire list 

&top("Compose Message"); 
print qq~ 
<center>List: $list_name<p></center>

<form action=$ENV{'SCRIPT_NAME'} method=POST> 
<table width=450 cellpadding=3 cellspacing=3><tr><td> 
To: </td><td><input type=text size="50" name="to" value="~; 
print @to; 
print qq~"> 
</td></tr><tr><td>Subject:</td><td> 
<input type=text size="50" name="subject"></td></tr> 
</table> 

<table with=450 cellpadding=3 cellspacing=3><tr><td> 
Message:<br> 
<textarea name="body" cols=60 rows=15></textarea> 
<p> 
<input type=submit name=action value="send"><input type=submit value="cancel"><input type=reset value="reset"> 
</form> 
</td></tr></table> 

~; 

&sig; 
&bottom; 
} 

#******************************************** 
# 
# Delete entries from the database 
# 
#******************************************** 

sub delete{ 

# deleting selected entries 
dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg="Unable to open $db_data_path/emails"); 
my (@allkeys) = keys(%FORM); 
&top("$list_name Admin delete records"); 
foreach $key (@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
if ($FORM{$key} eq 'delete' && $key ne 'action'){ 
delete($DB{$key}); 
print "Deleting <strong>$email</strong> with ID <strong>$key</strong><br>"; 
} 
} 
dbmclose(%DB); 
&sig; 
&bottom; 
} 

#************************************** 
# 
# Searching the database for entries 
# 
#************************************** 

sub search{ 
my ($email, $day, $month, $year, $m, $mf, $mt, $d, $df, $dt, $y, $yf, $yt); 

# we need to search for something 
if ($FORM{'q'} eq ''){ &error($errmsg = "You need to search for something"); } 

dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg="Unable to open $db_data_path/emails"); 

&top("$list_name Admin search"); 
print qq~ Select the entries you wish to delete<br> 
or select the entries you wish to send a message to 
<br> 
<form action="$ENV{'SCRIPT_NAME'}" method=POST> 

~; 



# search in the $email 
my (@allkeys) = keys(%DB); 
if ($FORM{'type'} eq 'email'){ 
foreach $key (@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 

# do an exact search 
if ($FORM{'match'} eq 'exact'){ 
if($FORM{'q'} eq $email){ 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 
} else { 
# do an inexact search 
if ($email =~ /$FORM{'q'}/){ 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 
} 
} 

# search by ID 
} elsif ($FORM{'type'} eq 'id'){ 
if ($FORM{'mathc'} eq 'inexact'){ 
foreach $key (@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
if ($key =~ /$FORM{'q'}/){ 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 
} 
} else { 
$key = $FORM{'id'}; 
if(!$DB{$key}){ &error($errmsg = "Could not locate $key"); } 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 

# search for all entries before a date mm/dd/yyyy 
} elsif ($FORM{'type'} eq 'before'){ 
($m, $d, $y) = split(/\//, $FORM{'q'}); 
my $number_of_days = $y*365 + $m*30 + $d; 
foreach $key(@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
$month++; 
my $this_number_of_days = $year*365 + $month*30 + $day; 
if ($number_of_days >= $this_number_of_days){ 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 
} 

# search for all entries after a date mm/dd/yyyy 
} elsif ($FORM{'type'} eq 'since'){ 
($m, $d, $y) = split(/\//, $FORM{'q'}); 
my $number_of_days = $y*365 + $m*30 + $d; 
foreach $key(@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
$month++; 
my $this_number_of_days = $year*365 + $month*30 + $day; 
if ($number_of_days <= $this_number_of_days){ 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 
} 

# search for a range of dates mm/dd/yyyy-mm/dd/yyyy 
} elsif ($FORM{'type'} eq 'range'){ 
($from, $to) = split(/-/, $FORM{'q'}); 
($mf, $df, $yf) = split(/\//, $from); 
my $number_of_days_from = $yf*365 + $mf*30 + $df; 
($mt, $dt, $yt) = split(/\//, $to); 
my $number_of_days_to = $yt*365 + $mt*30 + $dt; 
foreach $key (@allkeys){ 
($email, $day, $month, $year) = split(/\t/, $DB{$key}); 
$month++; 
my $this_number_of_days = $year*365 + $month*30 + $day; 
if ($this_number_of_days <= $number_of_days_to && $this_number_of_days >= $number_of_days_from){ 
print qq~ 

<table width=300><tr><td> 
Delete:<input type=radio name="$key" value="delete"><br> 
Mailto:<input type=radio name="$key" value="mailto"><br> 
</td><td><b>$email</b></td></tr></table> 

~; 
} 
} 
} 
dbmclose(%DB); 
print qq~ 

<input type=submit name="action" value="delete"><input type=submit name=action value="mailto"><input type=reset value="reset"></form> 

~; 

&sig; 
&bottom; 
} 
#*************************************************** 

sub batch{ 

&top("Batch Subscription to list: $list_name "); 

my @maillist;
#
# since POST method is used in this form
# the contents of the pastearea is stored into $buffer
# by the data_parse  subroutine
# At the beginnibg of the $buffer there is a "pastearea=" string
# that we must get rid of and also %0D%0A between each email addr
#
# At the end there is a \n\n&action=Batch+Subscribe" string
#
# If the "sendmail" option is checked, $buffer contains the string
# "sendmail=yes"

$mailwillbesent = "no";
if ($buffer =~ /sendmail=yes/i) {$mailwillbesent = "yes"};
$buffer =~ s/pastearea=//;    # get rid of "pastearea="
$buffer =~ s/%0D%0A/\+/gi;
$buffer =~ /&action=/gi;
$buffer = $`;   # $` is the part of the string before the match str
$buffer =~ /&sendmail=/gi;  # get rid of this text too if it exists
$buffer = $`;   # $` is the part of the string before the match str


@maillist = split(/\+/,$buffer);
$nlist = @maillist;
if ($nlist eq 0) {
   print qq~

   You must enter at least one valid email address

~;
}
print "$nlist entries to add...<p>\n";

&unix_to_time;

dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg = "Unable to open $db_data_path/emails"); 
OUTER:foreach $i (@maillist) {
  $i=&clean_escapes($i); # get rid of browser escapes (% stuff)
  #
  # the clean_escapes routine converts %40 to \@
  # but here we must not have the @'s escaped here.
  # substitute all \@ with @
  $i=~ s/\\\@/\@/g;
  # get rid of all blanks
  $i=~ s/ //g;
  if ( $i eq "") { next OUTER };

  # does the mail addr look like a valid one?
  $temp = $i;
  $temp =~ s/-/a/g;   # get rid of any - so that \W in patt matching test works
  $temp =~ s/_/a/g;   # get rid of any _ so that \W in patt matching test works
  unless ( $temp =~ /\w+\@\w+\.\w\w+/) {
             print "$i : Looks invalid, not added to db.<br>\n";
             next OUTER;
             }

  # Make sure the user does not already exist in db

  @allkeys=keys(%DB);

  foreach $key(@allkeys){
    my ($temail, $tday, $tmonth, $tyear) = split(/\t/, $DB{$key});
    if ($temail eq $i) {print  "$i already exists!<br>\n";
                            next OUTER;}
  }

  #  everything OK. appe to db
  while (!$cid){
      $n = int(rand(time));
      unless ($DB{$n}) {
             $cid = $n;
             }
  }
  my ($info) = "$i"."\t"."$day"."\t"."$month"."\t"."$year";
  $DB{$cid} = $info;
  $assignedcid = $cid;
  undef $cid;  # so that while(!$cid) works...
  print "$i added...";
  
  if ( $mailwillbesent eq "yes") {
open(MAIL, "|$mailprogram -t");
print MAIL "From: $yourname <$youremail>\n";
print MAIL "Subject: Your subscription to $list_name\n";
print MAIL "X-Mailer: WASPII List Manager 3.0 \n";
print MAIL "Precedence: bulk\n";
print MAIL "To: $i\n\n";
print MAIL "Hello,\n\n";
print MAIL "Your e-mail address has been added to our mailing list\n";
print MAIL "$list_name / $title.\n";
print MAIL "You can contact the list administrator at $youremail\n\n";
print MAIL "If you want to unsubscribe from this list or subscribe\n";
print MAIL "to other available $title lists please point\n";
print MAIL "your browser to the URL:\n";
print MAIL "\n";
print MAIL "http://$ENV{'HTTP_HOST'}/$waspii_root/lists.htm\n\n";
print MAIL "\n";
print MAIL "\n";
print MAIL "Sincerely, \n$yourname\n";
print MAIL "$youremail\n";

close(MAIL);
print "Mail sent...";
  }
print "<br>\n";
 
}
print "<p>\n";

dbmclose(%DB);

&sig; 
&bottom; 
} 

#******************************************** 
# 
sub listall{

&top("Subscriber List: $list_name ");

dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg = "Unable to
 open $db_data_path/emails");

  @allkeys=keys(%DB);

  foreach $key(@allkeys){
    my ($temail, $tday, $tmonth, $tyear) = split(/\t/, $DB{$key});
    print "$temail subscribed on $tday/$tmonth/$tyear </font><br>\n";
  }

dbmclose(%DB);
print "<p>--- End of list ---<p>\n";

&sig;
&bottom;
}

#******************************************** 
# 
sub deleteall{

&top("Subscriber List: $list_name ");

dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg = "Unable to
 open $db_data_path/emails");

  @allkeys=keys(%DB);

  foreach $key(@allkeys){
    my ($demail, $dday, $dmonth, $ dyear) = split(/\t/, $DB{$key});
    delete($DB{$key});
    print "$demail deleted...<br>\n";
  }

dbmclose(%DB);

&sig;
&bottom;
}

#********************************************** 
# 
# Admin main page 
# 
#********************************************** 

sub main{ 
# get the number of entries 
dbmopen(%DB, "../$db_data_path/emails", 0600) or die &error($errmsg = "Unable to open $db_data_path/emails"); 
my (@allkeys) = keys(%DB); 
my ($n) = scalar(@allkeys); 
dbmclose(%DB); 
&top("$list_name Administration"); 
print qq~ 
<a name="menu">
<center>There are <b>$n</b> email addresses in the database. </center>
<p> 
<h3>You can :</h3>
<blockquote>
<table>
<tr><td valign="top">
<a href="$ENV{'SCRIPT_NAME'}?action=compose">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" align="top" border="0"></a>
    </td>
    <td>
    Compose and send a mail to subscribers of this list,
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="#batchsubs">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Add e-mail address(es) to this list,
    <p>
    </td> </tr>
    <tr><td> </td></tr>

<tr><td valign="top">
<a href="http://$httphost/$relative_cgi/$waspii_root/$folder/admin/admin.cgi?action=List+All">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    List the subscribers of this list, 
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="http://$httphost/$relative_cgi/$waspii_root/$folder/admin/edit.cgi">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Modify the parameters of this list, (modify the config.pl file)
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="$ENV{'SCRIPT_NAME'}?action=cleanup">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Cleanup the confirmation database to remove entries which have not been confirmed for more than 15 days, 
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="$ENV{'SCRIPT_NAME'}?action=backup">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Make a backup copy of your subscriber database now,
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="$ENV{'SCRIPT_NAME'}?action=restore">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Restore a subscriber database from your backup copy, 
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="http://$ENV{'HTTP_HOST'}/$relative_cgi/$waspii_root/$folder/admin/rmlist.cgi">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Remove this list as a whole together with its subscriber database, 
    <p>
    </td> </tr>

<tr><td valign="top">
<a href="#searchstuff">
   <img src="http://$httphost/$waspii_root/images/redarr.gif" border="0"></a>
    </td>
    <td>
    Search for a record or a group of records in this list's subscriber database. 
    <p>
    </td> </tr>
</table>
<p><hr>
</blockquote>
<blockquote>
<img src="http://$httphost/$waspii_root/images/space.gif" height="250" align="top" border="0"></a>

<a name="searchstuff">
<hr>
<h3>Search Records</h3>
<blockquote>
<br> 
To see all addresses, do an inexact Email search for \@. 
<form action="$ENV{'SCRIPT_NAME'}" method=GET> 
<input type=hidden name=action value=search> 
What should i search for?<br> 
<table> 
<tr><td>Email address:</td><td><input type=radio name=type value="email" checked></td></tr> 
<tr><td>ID:</td><td><input type=radio name=type value="id"></td></tr> 
<tr><td>Added since <b>mm/dd/yyyy</b></td><td><input type=radio name=type value="since"></td></tr> 
<tr><td>Added before <b>mm/dd/yyyy</b></td><td><input type=radio name=type value="before"></td></tr> 
<tr><td>Date Range <b>mm/dd/yyyy-mm/dd/yyyy</b></td><td><input type=radio name=type value="range"></td></tr> 
<tr><td>Exact Match: </td><td><input type=radio name=match value="exact"></td></tr> 
<tr><td>Inexact Match: </td><td><input type=radio name=match value="inexact" checked></td></tr> 
<tr><td>Search for:</td><td><input type=text name="q" value=""></td></tr> 
<tr><td><input type=submit value=" Search "> 
<input type=submit name=action value="List All"> 
<input type=submit name=action value="Delete All">
</td><td><input type=reset value= "Reset"><p></td></tr> 
<tr><td><a href="#menu"><p><font color="#ff0000"><b>Back to top</b></font></a></td></tr>
</table> 
<img src="http://$httphost/$waspii_root/images/space.gif" height="250" align="top" border="0"></a>
</form> 
<p> </blockquote>

<p><a name="batchsubs">
<hr><p>
<font size="+1"><b>Batch Subscription</font></b><p>

<form action="$ENV{'SCRIPT_NAME'}" method="POST"> 
Enter or paste email addresses to subscribe (one per line) to the box below:<p> 
<textarea name="pastearea" rows=15 cols=60></textarea>

<p> 
<input type=checkbox name="sendmail" value="yes"> Check here to send a subscription notification mail to each subscribed user. If you don't check this box, all the above users will be subscribed to your list without any notification. <P>
<input type=submit name="action" value="Batch Subscribe"><br>
<p>
<a href="#menu"><p><font color="#ff0000"><b>Back to top</b></font></a>
</form> 
<p> 
~; 

&sig; 
&bottom; 
}
