#!/usr/bin/perl -U
# ------------- 
# WASPII List Manager 
# ------------- 
# Email list manager 
# 
# File: edit.cgi 
# Description: Admin WEB Interface to change list params
# Author: Can Ugur Ayfer
# 
#==================================================================== 

# the path to config.pl on your server 
require '../config.pl'; 

# When config.pl is executed the following list params are set into
# corresponding variables:

#
#  var name     usage
#  =========    =================================================
#  $title       as is. 
#  $folder      as is.
#  $list_name   as is.
#  $youremail   as is. (admin's email)
#  $mailprogram    as is. (usually "/usr/lib/sendmail")

#  $allow_web_subs    "yes" or "no"
#  $allow_web_unsubs  "yes" or "no"
#  $auth              "ip" or "user" 
#  $htpasswd     usually "/usr/bin/htpasswd"
#  $cgi_url      usually "/cgi-bin/list/$folder"
#  $cgi_root     usually "/home/httpd/cgi-bin"
#  $http_root    usually "/home/httpd/html"
#  $relative_cgi  usually "cgi-bin"
#  the rest of the vars set in config.pl are not our concern
#
#  The following information should be retrieved from the ../admin/dotfiles
#
#  If the list administration authentication is based on IP addresses,
#  the file $folder/admin/.hosts.admin contains the IP addresses,
#  one admin host IP on each line
#
#  If the list administration authentication is based on UserID's (protection
#  is done by the http daemon in conjunction with .htpasswd.
#  Administrator users are declared in $folder/admin/.htpasswd file,
#  one user per line in username:password format. The problem with this
#  file is that the passwords are stored encrypted. So we cannot simply 
#  edit this file. we must either add or remove lines.

#

require "../$subs_path"; 
#
# Lets first see whether the user is authorized to run this script?
#
#  Check IP based Authentication is selected
#  (User based admin auth is taken care by httpd/.htpasswd scheme)
#
if ($auth eq "ip") {
   #
   #  check if user's IP is in this list
   #
   $user_is_admin = &check_admin(".hosts.admim");
   if ( $user_is_admin ne "yes" ) {
      die &error($errmsg="You are not allowed to administer this list!");
   }

}    # continue if IP is  authorized or IP authentication is not selected

$form_allow_web_subs = "checked";
if ($allow_web_subs eq "no" ) {$form_allow_web_subs = "" };
$form_allow_web_unsubs = "checked";
if ($allow_web_unsubs eq "no" ) {$form_allow_web_unsubs = "" };
$ip_checked = "checked";
$user_checked = " ";
if ($auth eq "user" ) {$ip_checked = " " ; $user_checked = "checked"};
# 
# fill the IP_list and User_list boxes
#

$userlist = "";
@users = ("");
if ($auth eq "user") {
   open(HTPASSWD, ".htpasswd") || ($userlist="Cannot open .htapasswd");
   while (<HTPASSWD>){
         ($name_part, $password_part) = split(":",$_);
         @users = (@users, $name_part);  #add username to users list
         $userlist = $userlist . $name_part . "\n";
   }
   close(HTPASSWD);
}
$hostlist = "";
   open(HOSTS, ".hosts.admin") || ($hostlist="Cannot open .hosts.admin");
   while (<HOSTS>){
         $hostlist = $hostlist . $_;  # \n are coming from the file
   }
   close(HOSTS);

print "Content-Type: text/html\n\n";
print qq~

<html>

<head>
<meta http-equiv="Content-Type"
content="text/html; charset=windows-1254">
<meta name="GENERATOR" content="Microsoft FrontPage Express 2.0">
<title>Creating a New Announcement List(</title>
</head>

<body bgcolor="#000055" text="#FFFFFF" link="#FFFFFF"
vlink="#FFFFFF" alink="#FFFFFF">
<div align="center"><center>

<table border="0" cellpadding="0" cellspacing="0" width="90%">
    <tr>
        <td colspan="2" width="100%"><p align="center"><img
        src="/$waspii_root/images/weblogo2.gif" width="293" height="44"></p>
        <p align="center"><font size="4" face="Arial"><strong>Editing
        Announcement List Parameters<br>
        </strong></font><font size="2" face="Arial">(You must
        fill all fields)</font>
       <br><font size="-2">Your IP: $ENV{'REMOTE_ADDR'}</font><br>
       <p align="center">
        <font color="#ffff00"><b>Modify the field(s) you want and click the<br>
        adjacent yellow button(s) to save.</b></font><p>
        </td>
    </tr>
    <tr>
        <td colspan="2"><form
        action="http://$ENV{'HTTP_HOST'}/$relative_cgi/$waspii_root/$folder/admin/update.cgi"
        method="POST" name="myform">
            <div align="center"><center><table border="0"
            cellpadding="6" cellspacing="1" width="99%">
                <tr>
                    <td align="right" valign="top" width="35%"><font
                    size="2" face="Arial"><strong>Title for your
                    list's web pages and meta tag descriptions:<br>
                    </strong></font><font size="1" face="Arial">(30-35
                    chars)<br>
                    Will appear as web page title and browser
                    window title</font></td>
                    <td valign="top" width="65%"><input
                    type="text" size="35" name="title"
                    value="$title">
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_title alt="Click to update Title">
                    </td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>Name for the list:<br>
                    </strong></font><font size="1" face="Arial">(Will
                    appear in confirmation mails, lists web pages
                    etc. Type a name of approx 25 chars.)<br>
                    e.g.: Exhibition Announcements</font></td>
                    <td valign="top"><font size="1" face="Arial"><input
                    type="text" size="30" name="name" value=\"$list_name\">
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_list_name alt="Click to update ListName">
                    </font></td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>List Administrator's
                    e-mail:<br>
                    </strong></font><font size="1" face="Arial">Fully
                    qualified, valid e-mail address please.<br>
                    e.g. : cayfer\@bilkent.edu.tr </font></td>
                    <td valign="top"><input type="text" size="20"
                    name="email" value=\"$youremail\">
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_admin_mail alt="Click to update Admin's e-mail">
                    </td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>Path to your system's
                    sendmail:</strong></font><font size="1"
                    face="Arial"><br>
                    e.g. : /usr/lib/sendmail</font></td>
                    <td valign="top"><input type="text" size="20"
                    name="sendmail" value="$mailprogram">
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_sendmail alt="Click to update sendmail path">
                    <br>
                    <font size="1" face="Arial">*** Don't change
                    if you are not sure! ***</font></td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>Allow web subscriptions?</strong>
                    </font><font size="1" face="Arial"><br>
                    Would you like to have people subscribing
                    themselves over the web?</font></td>
                    <td valign="top"><input type="checkbox"
                    $form_allow_web_subs  name="subs" > <font
                    size="2" face="Arial">Yes, allow web
                    subscriptions.</font>
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_web_subs alt="Click to update">
                    </td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>Allow web
                    UnSubscriptions?</strong></font><font
                    size="1" face="Arial"><br>
                    Would you like to let your subscribers
                    unsubscribe themselves over the web?</font></td>
                    <td valign="top"><input type="checkbox"
                    $form_allow_web_unsubs name="unsubs" > <font
                    size="2" face="Arial">Yes, allow web
                    UnSubscriptions.</font>
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_web_unsubs alt="Click to update">
                   </td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>Do you want IP # based
                    or UserID based administrator authentication?</strong>
                    </font></td>
                    <td valign="top"><input type="radio"
                    name="auth" $ip_checked value="ip"> <font size="2"
                    face="Arial">IP Based</font><br>
                    <font size="2" face="Arial"><input
                    type="radio" $user_checked name="auth" value="user">
                    UserID Based</font>
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_auth alt="Click to update Authentication method">
                   </td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>IP Numbers of
                    administrator host(s): </strong></font><font
                    size="1" face="Arial"><br>
                    One IP per line. Users accessing the
                    announcement lists system from these hosts
                    will be granted administrative rights.</font></td>
                    <td valign="top"><textarea name="iplist"
                    rows="4" cols="20">$hostlist</textarea>
                    <INPUT type="image" src=\"/$waspii_root/images/upd.gif\" border=\"0\" hspace=\"4\" name=upd_iplist alt="Click to update IP list">
                    <br>
                    <font size="2" face="Arial" >Use only if you
                    have selected <br>
                    <strong>IP Based</strong> admin.
                    authentication.</font></td>
                </tr>
                <tr>
                    <td align="right" valign="top"><p>&nbsp;</p>
                    </td>
                    <td valign="top"><font face="Arial">
                    <p>
                             </font>
                    </td>
                </tr>
                <tr>
                    <td align="right" valign="top"><font size="2"
                    face="Arial"><strong>Admin user(s):</strong></font>
                       <br><font size="1">Click the user you want to delete and 
                      click the DEL button<p></font><font
                    size="1" face="Arial">
                    </font></td>
                    <td valign="top">
~;
 print "<SELECT NAME=\"Selection\"  SIZE=\"4\">";
 if ($auth eq "user") {
    while (<@users>) {
       print "<OPTION> $_";
    }
 }
 print "</SELECT>";
 print " ";
 print " <input type=\"image\"  src=\"/$waspii_root/images/del.gif\" hspace=\"4\" alt= \"Delete Selected Admin User\" border=\"0\" name=\"Delete User\"><br>";


print qq~
                    <font size="2" face="Arial">Use only if you
                    have selected <br>
                    <strong>UserID Based</strong> admin.
                    authentication.</font>
                     <p>
                    </td>
                    
                </tr>

                <tr>
                   <td align="right" valign="top"><font size="2"
                     face="Arial"><strong>Add a new admin.
                     </strong></font><font
                     size="1" face="Arial"><br>
                     One admin/passwd at a time. Type a / between the UserID 
                     and the password.  </font></td>
                    <td valign="top"><input type="text" size="20"
                    name="addedadmin" value="Username/Passwd"> 
                    <input type="image" src="/$waspii_root/images/add.gif"
                     alt="Add new admin user" hspace="4" border="0" 
                     name="Add" > <br>
                     <font size="2" face="Arial" >Use only if you
                     have selected <br>
                     <strong>UserID Based</strong> admin.
                      authentication.<br>
                    </font><p><hr></td>
                 </tr>



            </table>
            </center></div><p>&nbsp;</p>
            <p>&nbsp;</p>
        </form>
        </td>
    </tr>
</table>
</center></div>
</body>
</html>
~;

