#!/usr/bin/perl -U
# ------------- 
# WASPII List Manager 
# ------------- 
# Email list manager 
# 
# File: rmlist.cgi 
# Description: Removes a list's folder 
# Author: Can Ugur Ayfer
# 
#==================================================================== 

# the path to config.pl on your server 
require '../config.pl'; 

# When config.pl is executed the following list params are set into
# corresponding variables:

#
#  var name     usage
#  =========    =================================================
#  $title       as is. 
#  $folder      as is.
#  $list_name   as is.
#  $youremail   as is. (admin's email)

#  the rest of the vars set in config.pl are not our concern
#
#  The following information should be retrieved from the ../admin/dotfiles
#
#  If the list administration authentication is based on IP addresses,
#  the file $folder/admin/.hosts.admin contains the IP addresses,
#  one admin host IP on each line
#
#  If the list administration authentication is based on UserID's (protection
#  is done by the http daemon in conjunction with .htpasswd.
#  Administrator users are declared in $folder/admin/.htpasswd file,
#  one user per line in username:password format. The problem with this
#  file is that the passwords are stored encrypted. So we cannot simply 
#  edit this file. we must either add or remove lines.

#

require "../$subs_path"; 
#
# Lets first see whether the user is authorized to run this script?
#
#  Check IP based Authentication is selected
#  (User based admin auth is taken care by httpd/.htpasswd scheme)
#
if ($auth eq "ip") {
   #
   #  check if user's IP is in this list
   #
   $user_is_admin = &check_admin(".hosts.admin");
   
   if ($user_is_admin ne "yes") 
         { die &error($errmsg="You are not authorized to administer the list!");
         }

}    # continue if IP is  authorized or IP authentication is not selected

print "Content-Type: text/html\n\n";
print qq~

<html>

<head>
<meta http-equiv="Content-Type"
content="text/html; charset=windows-1254">
<meta name="GENERATOR" content="Microsoft FrontPage Express 2.0">
<title>Removing an Announcement List(</title>
</head>

<body bgcolor="#000055" text="#FFFFFF" link="#FFFFFF"
vlink="#FFFFFF" alink="#FFFFFF">
<p> <p>
<font size="+2"><center>Are you sure that you want to remove<br>
the following list from this system?</center></font>
<p><p>
<table width="%75" align="center">
<tr>
<td>Title<td><td>$title</td>
</tr>
<tr>
<td>Name<td><td>$list_name</td>
</tr>
<tr>
<td>Admin<td><td>$youremail</td>
</tr>
<tr>
<td>Folder<td><td>$folder</td>
</tr>
</table>
<p><hr width="200">

<form action="http://$ENV{'HTTP_HOST'}/$relative_cgi/$waspii_root/$folder/admin/remove.pl" method=POST>
<center>If you really want to remove the list, <br>
type "yes" in the box and click continue.<p>
<input type="text" name=yes value="No" size="3"><p>
<input type="submit" name=sub value="Continue">
</center>

</body>
</html>
~;

