#!/usr/bin/perl -U
# ------------- 
# WASPII List Manager 
# ------------- 
# Email list manager 
# 
# File: update.cgi 
# Description: Updates list params as entered in the web page presented by 
#              edit.cgi
# Author: Can Ugur Ayfer
# 
#==================================================================== 

# the path to config.pl on your server 
require '../config.pl'; 

require '../list_subs.pl';

&top("Update List Params");
$_ =  <STDIN>;   # because METHOD is GET 

@pairs = split("&", $_);

#
# Which button was pressed to come here? 
#
##############################
#  
#  upd_title button pressed
#
##############################
#
# Please note that since we are using imahe buttons,
# the browsers are sending button names two times each, 
# one appended with ".x" and the other appended with ".y".
#

if ( /upd_title\.x/ ) { 
# 
# get the new title
# 
while (<@pairs>) {
      if ( /^title=/i ) {
         ($dummy, $form_title) = split("=", $_);
         $form_title = &clean_escapes($form_title);  # get rid of space etc 
         if ( $form_title eq "" ) {last};  # do nothing if title is all blanks
         &put_config("title", $form_title);
         last;
      }
}
}
##############################
#
#  upd_list_name button pressed
#
##############################
#
# Please note that since we are using imahe buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_list_name\.x/ ) {
#
# get the new list name
#
while (<@pairs>) {
 if ( /^name=/i ) {
 ($dummy, $form_name) = split("=", $_);
 $form_name = &clean_escapes($form_name);  # get rid of space etc 
 $form_name =~ s/ //g;    # get rid of spaces
 if ($form_name eq "" ){last};  # do nothing if title is all blanks
         &put_config("list_name", $form_name);
         &put_config("yourname", $form_name);
         last;
      }
}
}
##############################
#
#  upd_admin_mail button pressed
#
##############################
#
# Please note that since we are using imahe buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_admin_mail\.x/ ) {
#
# get the new admin_mail addr
#
while (<@pairs>) {
      if ( /^email=/i ) {
         ($dummy, $form_youremail) = split("=", $_);
         $form_youremail = &clean_escapes($form_youremail);  # get rid of space 
         $form_youremail =~ s/ //g;    # get rid of spaces
         if ( $form_youremail eq "" ) {last};  # do nothing if admin email is all blanks
         &put_config("youremail", $form_youremail);
         last;
      }
}
}
##############################
#
#  upd_sendmail button pressed
#
##############################
#
# Please note that since we are using image buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_sendmail\.x/ ) {
#
# get the new sendmail prog path
#
while (<@pairs>) {
      if ( /^sendmail=/i ) {
         ($dummy, $form_mailprogram) = split("=", $_);
         $form_mailprogram=&clean_escapes($form_mailprogram);  
         $form_mailprogram =~ s/ //g;    # get rid of spaces
         if ( $form_mailprogram eq "" ) {last};  # do nothing if sendmail is al l blanks
         &put_config("mailprogram", $form_mailprogram);
         last;
      }
}
}


##############################
#
#  upd_web_subs button pressed
#
##############################
#
# Please note that since we are using image buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_web_subs\.x/ ) {
#
# get the new web subscription setting
#
$found=0;
while (<@pairs>) {
      if ( /^subs=/i ) {
         &put_config("allow_web_subs", "yes");
         $found = 1;
         last;
      } 
}
# If cannot find subs=ON, that means user has turned the option OFF
if ( $found eq 0) {&put_config("allow_web_subs", "no")}
}


#############################
#
#  upd_web_unsubs button pressed
#
##############################
#
# Please note that since we are using image buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_web_unsubs\.x/ ) {
#
# get the new web unsubscription setting
#
$found = 0;
while (<@pairs>) {
      if ( /^unsubs=/i ) {
         &put_config("allow_web_unsubs", "yes");
         $found = 1;
         last;
      } 
}
# If cannot find unsubs=ON, that means user has turned the option OFF
if ($found eq 0 ) { &put_config("allow_web_unsubs", "no")}
} 

################################
#
#  upd_auth button pressed
#
##############################
#
# Please note that since we are using image buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_auth\.x/ ) {
#
# get the new admin authentication method
#
$found = 0;
while (<@pairs>) {
      if ( /^auth=user/i ) {
         &put_config("auth", "user");
         $found = 1;
         last;
      } 
}
# If cannot find auth=user, that means auth=ip is selected 
if ($found eq 0 ) { &put_config("auth", "ip")}

# if auth=user and .htaccess does not exist, create one.
# if auth=ip and .htaccess exists, remove it
if ($found eq 0)  { # auth is ip based
     unlink (".htaccess") || (1);
   }  else {  #  auth is user based
          open (HTACCESS, ">.htaccess")   || die &error($errmsg="Cannot c
reate $folder/admin/.htaccess");
          print HTACCESS "AuthUserFile $cgi_root/$waspii_root/$folder/admin/.htpasswd\n";
          print HTACCESS "AuthGroupFile /dev/null\n";
          print HTACCESS "AuthName \"Authorized Access Only!\"\n";
          print HTACCESS "AuthType Basic\n";
          print HTACCESS "\n";
          print HTACCESS "<Limit GET>\n";
          print HTACCESS "require valid-user\n";
          print HTACCESS "</Limit>\n";
          print HTACCESS "\n";
          close (HTACCESS);
   }
} 

################################
#
#  upd_iplist button pressed
#
##############################
#
# Please note that since we are using image buttons,
# the browsers are sending button names two times each,
# one appended with ".x" and the other appended with ".y".
#
if ( /upd_iplist\.x/ ) {
   #
   # get the new iplist
   #
   while (<@pairs>) {
         if ( /^iplist=/i ) {
            ($dummy, $hosts) = split("=", $_);
            @host_array = split("%0D%0A", $hosts);
            unlink ("temp");
            open(TEMP, ">temp");
            print "<h3>Modified $folder/.hosts.admin file now is:</h3><p>";
            while (<@host_array>) {
                 $_ = &clean_escapes($_);
                 print "$_ <br>";
                 $_ =~ s/ //g;    # get rid of blanks
                 if ( $_ eq "" ) { next }
                 print TEMP "$_\n";
            }
            close(TEMP);
            system ("/bin/cp temp .hosts.admin");
            unlink("temp");

            print "--- eof ---<p><p><p>";
            &return_button;
            last;
         } 
   }

}

#############################
#
# Delete User button pressed
#
#############################
#
# Please note that since we are using imahe buttons,
# the browsers are sending button names two times each, 
# one appended with ".x" and the other appended with ".y".
#
if ( /Delete\+User\.x/i ) {   # Selected username should be removed from the 
                          # .htpasswd file.
   #
   # parse @pairs to get the name of the user 
   # to be deleted from .htpasswd
   #
   while(<@pairs>) {
        if ( /Selection=/i ) { #  "Selection=" found
             ($dummy, $selected_name) = split ("=", $_);
             open(HTPASSWD, ".htpasswd");
             open(TEMP, ">temp");
             while(<HTPASSWD>) {
                  if ( /$selected_name:/ ) {next} # skip the selected name
                  print TEMP $_;
             }
             close(TEMP);
             close(HTPASSWD);
             system ("/bin/cp temp .htpasswd");
             system ("/bin/rm temp");
             print "Admin user \"$selected_name\" removed from .htpasswd<p><p>";
             &return_button;
        } 
   }

}
#####################
#
# ADD BUTTON Pressed
#
#####################
#
# Please note that since we are using imahe buttons,
# the browsers are sending button names two times each, 
# one appended with ".x" and the other appended with ".y".
#

if ( /Add\.x/i ) { 
   #
   # parse @pairs to get the name of the user
   # to be added to .htpasswd
   #
   while(<@pairs>) {
   if ( /addedadmin=/i ) { #  "addedadmin=" found
     ($dummy, $added_name_passwd) = split ("=", $_);
      $added_name_passwd =~ s/%2F/\//gi;  # Get rid of escaped / chars
      #
      # Has the user entered a "/" between name and passwd?
      #
      ($admin_name, $admin_passwd) = ("Username", "Passwd");
      if ( $added_name_passwd =~ /.\/./) {
          ($admin_name, $admin_passwd) = split ("/", $added_name_passwd);
      }
      #
      # See if user has typed in a valid uname/passwd pair
      # blank entry or the default text "Username/Passwd" is not acceptable
      #
      $error_flag = 0;
      $err_msg = "<font color=\"#ff0000\"><b>Error: </b></font>Invalid Username/Passwd pair.<p>";

      if ($admin_name eq "Username") {
         print "$err_msg";
         $error_flag = 1;
      }
      if (($admin_passwd eq "Passwd") && ($error_flag eq 0)) {
         print "$err_msg";
         $error_flag = 1;
      }
      #
      # If username/passwd pair looks OK, check if the user already exists
      #
      if ($error_flag eq 0) {
         open(HTPASSWD, ".htpasswd");
         while(<HTPASSWD>) {
              if ( /^$admin_name\b/ ) {
                 $error_flag = 1;
                 print "<font color=\"#ff0000\"><b>Error: </b></font>Duplicate Username<p>";
                  last;
              }
         }
         close(HTPASSWD);
      }
      if ($error_flag eq 0) {
         system ("$htpasswd -b $cgi_root/$waspii_root/$folder/admin/.htpasswd $admin_name $admin_passwd");
         print "Admin user \"$admin_name\" added with password \"$admin_passwd\"<p><p>";
       }
      &return_button;

   }
}
}

&sig;
&bottom;



sub put_config {
#
# called with two args:
#   1. line identifier (the line to be changed in config.pl
#      starts with "$".$_[0]=
#   2. Value to be assigned to the variable described in $_[0]
#
#   Eg: if this func is called as &put_config("title", $form_title)
#       the line which contains $title= is searched in config.pl
#       and is replaced by a line which reads
#       $title="{value of $form_title}";
#
open(CONFIG, "../config.pl") || print "Cannot open ../config.pl<p>" ;
unlink ("temp");
open(TEMP, ">temp")|| print "Cannot open temp file<p>";
print "<h3>Modified $folder/config.pl file now is:</h3><p>";
while(<CONFIG>) {
  $dummy = $_;
  # strip all blanks
  $dummy =~ s/ //g;
  if ( $dummy=~ /^\$$_[0]=/ ) {  #  if the beginiinig of line is
                                 #  something like $time=
      print TEMP "\$".$_[0]."=\"$_[1]\"\;\n";
      print  "\$".$_[0]."=\"$_[1]\"\;<br>";
  } else {
      print TEMP $_;
      print  "$_<br>";
  }
}
close(TEMP);
close(CONFIG);

system ("/bin/cp temp ../config.pl");
unlink ("temp");
print "--- eof ---<p>";


}


sub return_button {
  print "<form action=\"http://$ENV{'HTTP_HOST'}/$relative_cgi/$waspii_root/$folder/admin/edit.cgi\">";
  print "<input type=\"Submit\" value=\"Continue\" name=\"Continue\">";
  print "</form>";
  1;
}
