#!/usr/bin/perl  -U
#
#  The -U parameter is necessary for most of the perl installations to work
#  properly with web
#
# ------------------- 
# WASPII List Manager 
# ------------------- 
# Email list manager 
# 
# File: config.pl 
# Description: Configuration file 
# Author: 
#         Original ASPII developed by Martin Kretzmann 
#         Email: martin@plebius.org 
#         Web: http://www.plebius.org 
#         Version: 2.0 
# Extended for administration over the web and handling multiple 
# lists done by Can Ugur Ayfer
#         cayfer@bilkent.edu.tr
#         Web : http://www.bilkent.edu.tr/~cayfer
#         Version 3.0
# 
#
#==================================================================== 
#
# http host: The host on which this service will run (fully qualif domain name)
#            eg: "listserver.abc.edu"
$httphost="hostname.dom";

# absolute location of the cgi-bin directory of the web server
#            eg: "/home/httpd/cgi-bin"
$cgi_root="/home/httpd/cgi-bin";

# relative location of the cgi-bin directory to the http root.
# Best explained by an example:
# If your http server is "http://lists.abc.edu" and you 
# permit cgi execution with URLs like http://lists.abc.edu/cgi-bin/myscript.cgi"
# then relative-cgi should be equal to "cgi-bin"
$relative_cgi = "cgi-bin";

# absolute location of the httpd document root for the web server
#            eg: "/home/httpd/html"
$http_root = "/home/httpd/html";

# name of the directory (relative to http_root and cgi_root) to hold WASPII
#             eg: waspii
#             if waspii_root = waspii; waspii scripts must be installed
#             under $cgi_root/waspii and waspii html files must be installed
#             under $http_root/waspii.
$waspii_root="waspii";


# meta description 
$meta_desc="Announcement Mailing Lists"; 

# meta keywords 
$meta_key = "waspii, announcement, mail, list, email"; 

# Title of your site, will appear on web pages, messages sent out, etc. 
$title="WASPII - Announcement System";

# your company name or your name, will appear as the sender's 
# name on mail messages 
$yourname="WASPII Announcements"; 

# Your list's name goes here, a short descriptive name for your list.
#  2 or 3 words typical.
$list_name='General Announcements';

# folder name for your list. The files related to a list will be
# stored in $cgi_root/$waspii_root/$folder
# Normally you don't need to change this and it is important that
# there a folder named TEMPLATE which holds the template files 
# used in creating new lists.
$folder="general";


# your email address BE SURE TO SET (be sure to escape @ as \@; modern
# Perl implementations require this!
$youremail="listmaster";
#
# $mail_to_admin : "yes" or "no". If "yes", a copy of sent mails is sent
# sent to the list administrator (to mail add in $youremail)
$mail_to_admin = "yes";

# Administrator authentication scheme ("ip" or "user")
# when auth=ip is selected, administration can only be using 
# browsers at these host(s). For the first time installation
# do not forget to create the file 
#      $cgi_root/$wasppi/TEMPLATE/admin/..hosts.admin
# this file should contain a list of IP numbers; one on each line; 
# for administration host(s). The file should be owned by nobody:nobody
# and mode 644.
# We do not recommend "user" based administration authentication
# for the main TEMPLATE list. It turns out to be more cumbersome to manage
# the overall system is "user" based authentication is selected for the
# TEMPLATE list. Leave it as it is if you have any doubts.
$auth="ip";

# Some lists are closed lists, that is they are not open to public for 
# subscription over the net. If you want only the admin to subscribe people
# to your list, change this param to "no". Since the TEMPLATE list is
# not visible on the web, you dont need to chnage this. Who would want to
# subscribe to a dead list, anyway.
# Will you permit web based subscriptions? ("yes" or "no")
$allow_web_subs="yes";

# In many institutions, especially schools, subscription to certain
# lists need to be compulsory. If you do not want people to be able to
# unsubscribe themselves over the web, switch the following param to "no".
# This param is meaningless for the TEMPLATE list, you can leave it as it is.
# Will you allow web based unsubscriptions? ("yes" or "no")
$allow_web_unsubs="yes";

# an extremely important parameter. Setting this wrong will 
# render you incapable of sending out announcement mail.
# Double check this path value before you proceed.
# path to sendmail or equivalent 
$mailprogram="/usr/lib/sendmail";

# Every http server (like Apache) has a htpasswd command to assist
# management of password protected web pages. Extremely important 
# if you are going to use "user" based admin authentication.
# path to htpasswd program or equivalent 
$htpasswd="/usr/bin/htpasswd"; 

$body = qq~body bgcolor="#000055" text="#ffffff" link="#ffffff" vlink="#ffffff" alink="#ffffff"~; 

# contents of normal size font tags 
$font = qq~font size=4 face="Arial, Helvetica"~; 

# contents of small font tags 
$font_small = qq~font size=3 face="Arial, Helvetica"~; 

#=============  End Of User Configurable Params  ===========
#
#   Normally, you wouldn't need to change anything from this
#                       point onwards.

# Relative URL to your site 
# leave blank if you have a full domain 
# instead of a subdirectory within a domain 
# No beginning slash 
$site_url = ''; 

# contents of the body tag 
# Relative URL to the directory where you will keep the script. 
# do NOT include the domain 
# No trailing slash 
# No beginning slash 
$cgi_url = "cgi\-bin/$waspii_root/$folder"; 
$http_cgi_url = "http://$httphost/cgi\-bin/list/$folder"; 

# sytem path to the data directory. No trailing slash. 
$db_data_path = 'data'; 

# system path to list_subs.pl 
$subs_path = 'list_subs.pl'; 

# name of the parts of the script, you won't need to change 
# these unless you change the name of the script 
$ax_name = 'ax.cgi'; 
$confirm_name = 'confirm.cgi'; 
$confirm_removal_name = 'confirm-removal.cgi'; 
$subscribe_name = 'subscribe.cgi'; 

1;
