#!/usr/bin/perl -U
# ------------- 
# WASPII List Manager 
# ------------- 
# Email list manager 
# 
# File: list_subs.pl 
# Description: Define page generation and 
# other various things 
# Author: Martin Kretzmann 
# Email: martin@plebius.org 
# Web: http://www.plebius.org 
# Version: 2.0 
# 
# Copyright 1999 Plebius Industries. All Rights Reserved. 
# 
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 2 of 
# the License, or (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software 
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
# Or visit http://www.plebius.org/scripts/license.html 
# 

#********************************************** 
# 
# This sub defines what will appear before all 
# output commands. 
# $info : subtitle 
# $meta_desc : meta description 
# $meta_key : meta keywords 
# $font : font tags 
# $font_small: small font tags 
# $body : contents of body tag 
# 
#********************************************** 

sub top{ 
local($info) = $_[0]; 

print "Content-Type: text/html\n\n"; 
print qq~ 

<html> 
<head> 
<TITLE>$title</TITLE> 
<meta name=keywords content="$meta_key"> 
<meta name=description content="$meta_desc"> 
<META NAME="OWNER" CONTENT="$title"> 
<META HTTP-EQUIV="CHARSET" CONTENT="ISO-8859-1"> 
<META HTTP-EQUIV="CONTENT-LANGUAGE" CONTENT="English"> 
</head> 
<$body> 

<center> 
<img border=0 src="/$waspii_root/images/weblogo2.gif" > 
<br> 
<table width=600 cellspacing=3 cellpadding=3><tr><td align=center nowrap><b> $info</b></td></tr></table> 
<!-- begin contents --> 
<table width=600 cellpadding=6 cellspacing=6><tr><td> 


~; 

$top_shown = 1; 
} 


#********************************************** 
# 
# This sub defines what will appear after all 
# output commands. 
# 
#********************************************** 

sub bottom{ 

print qq~ 


</td></tr></table> 
<!-- end content --> 

<table border=0 cellspacing=0 width=600> 
<tr> 
<td bgcolor=000033> 
<table border=0 cellspacing=0 cellpadding=0> 
<tr> 
<td height=2></td> 
</tr> 
</table> 
</td> 
</tr> 
</table> 

</center> 
</body></html> 


~; 

} 

#********************************************* 
# 
# We deliver the error message 
# 
#********************************************* 

sub error{ 
if (!$errmsg){ 
my $errmsg = $_[0]; 
} 
if (!$top_shown){ 
&top("Error"); 
} 
print "<$font color=red><b>ERROR:</b></font><p><$font>$errmsg</font><p>"; 
&sig; 
&bottom; 
exit; 
} 

#***************************************** 
# 
# This sub gets the time from unix time 
# so you can deal with it. You can change 
# what the months or days say to suit your 
# needs and desires. 
# 
#***************************************** 

sub unix_to_time{ 

# get the time 
($Second, $Minute, $Hour, $day, $month, $year, 
$dweek, $DayOfYear, $IsDST) = localtime(time); 

# get numerical month 
$realmonth = $month + 1; 

# don't forget Y2K 
$year = $year + 1900; 

# months in an array 
@months = ("January", "February", "March", "April", "May", 
"June", "July", "August", "September", "October", 
"November", "December"); 

# days in an array 
@days = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday"); 
} 


#********************************************* 
# 
# This sub takes the info from the form 
# and puts it into the array %FORM 
# 
#********************************************* 

sub data_parse{ 

# if not post, we use 
# the query as buffer 
if ($ENV{"REQUEST_METHOD"} eq 'POST') { 
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
} 
else { 
$buffer = $ENV{'QUERY_STRING'}; 
} 

# Put the data into variables 

@pairs = split(/&/, $buffer); 
foreach $pair (@pairs) { 
($name, $value) = split(/=/, $pair); 
$value =~ tr/+/ /; 
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
$FORM{$name} = $value; 
# filter out Server Side Includes 
$FORM{$name} =~ s/<!--(.|\n)*-->/ /g; 
} 
} 


#************************************************** 
# 
# Changing the following sub or any place it is 
# called is prohibited 
# according to the terms of the license 
# and international copyright law 
# 
#************************************************* 

sub sig{ 
print qq~ 

<hr color="#ffffff" width="200"><br> 

~; 

} 

# returns a value 
1;



sub clean_escapes {
#
# Cleans escaped special characters like spaces, parentheses etc
#
 $temp = $_[0];
 $temp =~ s/\@/\\\@/g;  # perl reqires @s be escaped
 $temp =~ s/\+/ /g;
 $temp =~ s/%40/\\\@/ig;
 $temp =~ s/%2F/\//ig;
 $temp =~ s/%23/\#/ig;
 $temp =~ s/%26/\&/ig;
 $temp =~ s/%24/\$/ig;
 $temp =~ s/%25/\%/ig;
 $temp =~ s/%27/\'/ig;
 $temp =~ s/%2B/\+/ig;
 $temp =~ s/%28/\(/ig;
 $temp =~ s/%29/\)/ig;
 $temp =~ s/%3F/\?/ig;
 $temp =~ s/%2C/\,/ig;
 $temp =~ s/%3B/\;/ig;
 $temp =~ s/%3A/\:/ig;
 $clean = $temp;
}


sub check_admin {
#
# Checks whether the client IP is listed in the .hosts.admin file
# which is he only parameter.
#
# Called as : $is_user_admin = &check_admin("./.hosts.admin");
#

#
# If user based admin authentication is selected for the list,
# httpd takes care of authentication. therefore we should return "yes".
# That is, if auth="user" and if the client ahs reached this point
# he/she is an administrator
#
if ($auth eq "user") {
   return("yes");
}


$myip = $ENV{'REMOTE_ADDR'};
$check_admin = "no";
# 
# if this host is mentioned in the .hosts.admin file
# of the waspii root, then he/she is certainly a admin
# regardless of the current list.
$host_file = "$cgi_root/$waspii_root/.hosts.admin";
$could_open = 1;
open(MASTER_ADMIN, $host_file) || ($could_open=0);
if ($could_open) {
   while(<MASTER_ADMIN>)  {
         chop($_);
         # 
         # There may be some comment after a # sign, get rid of it
         #
         if ( /\#/ ) { $_ = $` };

         $_ =~ s/ //g;
         if ($_ eq "") {next};
         $pos = index($myip, $_);
         if ($pos ne 0) {next};
         $check_admin = "yes";
         last;
   }
   close(MASTER_ADMIN);
    
}
if ($check_admin eq "yes") { 
    return("yes");
}


$host_file = $_[0];
$could_open = 1;
open(ADMIN, $host_file) || ($could_open=0);

if ($could_open) {
   while (<ADMIN>) {
         # 
         # There may be some comment after a # sign, get rid of it
         #
         if ( /\#/ ) { $_ = $` };

         chop($_);
         $_ =~ s/ //g;
         if ($_ eq "") {next};
         $pos = index($myip, $_);
         if ($pos ne 0) {next};
         $check_admin = "yes";
         last;
   }
   close(ADMIN);
}
$check_admin;
}

