#!/usr/bin/perl -U
# ------------- 
# File: subscribe.cgi 
# Description: Subscribe/Unsubs to the list 
# Author: Martin Kretzmann  / Features added by Ugur Ayfer
# Web: http://www.plebius.org 
# Version: 2.0 
# 
#==================================================================== 

# path to config.pl 
require 'config.pl'; 
require "$subs_path"; 


&data_parse; 
&decide; 


#****************************************** 
# 
# Decide what to do 
# 
#****************************************** 

sub decide{ 
if($FORM{'a'} eq 'remove'){ &remove; } 
elsif(!$FORM{'email'}){ &show; } 
elsif($FORM{'email'}){ 
&unix_to_time; 
&main; 
} else { &show; } 
} 

#******************************* 
# If they want to be removed 
#****************************** 

sub remove{ 
#************************************** 

my ($cid, $vid, $email, $n, $temp, @allkeys); 

#
# check whether web based unsubscription is allowed
#
if ( $allow_web_unsubs eq "no") {
  die &error($errmsg = "You are not allowed to UnSubscribe");
}

# check email 
$email = $FORM{'email'}; 
$temp = $email; 
$temp =~ s/-/a/g; 
$temp =~ s/_/a/g; 
unless ($temp =~ /\w+@\w+\.\w\w+/) { 
       &error($errmsg = "Invalid Email: $email"); 
       } 

&top("$list_name - Unsubscription Information"); 
dbmopen(%CDB, "$db_data_path/remove", 0600) or die &error($errmsg = "Unable to open $db_data_path/remove"); 
dbmopen(%DB, "$db_data_path/emails", 0600) or die &error($errmsg = "Unable to open $db_data_path/emails"); 


# make sure the email is already in the database 
@allkeys = keys(%DB); 

$found="no";
LOOP1:foreach $key(@allkeys){ 
my ($temail, $tday, $tmonth, $tyear) = split(/\t/, $DB{$key}); 
if ($temail eq $email){ 
              $found = "yes";
              last LOOP1;
              }
}
if ($found eq "no") {
        &error($errmsg = "The email $email is NOT in the database");  
} 

# select an ID and a confirmation ID 
$time = time; 
while(!$cid){ 
     $n = int(rand($time)); 
     unless ($CDB{$n} || $DB{$n}){ 
            $cid = $n; 
            $vid = int(rand($n)); 
     } 
} 
dbmclose(%DB); 

# add the record, if not successful we die 
my $info = "$vid"."\t"."$email"."\t"."$day"."\t"."$month"."\t"."$year"; 
unless($CDB{$cid} = $info){ 
       &error($errmsg = "Unable to add email to removal confirmaton list"); 
       } 
dbmclose(%CDB); 

# mail the confirmation 
open(MAIL, "|$mailprogram -t"); 
print MAIL "From: $yourname <$youremail>\n"; 
print MAIL "Subject: Your unsubscription to $list_name\n"; 
print MAIL "X-Mailer: WASPII List Manager 3.0 \n"; 
print MAIL "Precedence: bulk\n"; 
print MAIL "To: $email\n\n"; 
print MAIL "Hello,\n\n"; 
print MAIL "You have requested to be removed from \n"; 
print MAIL "our mailing list, $list_name.\n\n"; 
print MAIL "Before we can remove you from the list, however, we just\n"; 
print MAIL "need to verify that you really want to be out of it.\n"; 
print MAIL "If it wasn't you who gave us your email address,\n"; 
print MAIL "just delete this email and you will not be removed.\n"; 
print MAIL "Otherwise, simply point your browser to the URL:\n"; 
print MAIL "\n"; 
print MAIL "You must visit this page within 15 days, otherwise\n";
print MAIL "your unsubscription request will be cancelled.\n";
print MAIL "\n";
print MAIL "You can later subscribe to this list any time you want\n";
print MAIL "using the simple forms at address:\n";
print MAIL "http://$ENV{'HTTP_HOST'}/$waspii_root/lists.htm\n";
print MAIL "\n";
print MAIL "\n";
print MAIL "Sincerely, \n$yourname\n"; 
print MAIL "$youremail\n"; 

close(MAIL); 


# give the output 
print "<$font>A confirmation message has been sent to <b>$email</b><p>"; 
print "You will need to follow instructions in that email<br>"; 
print " in order to stop receiving mailings from this list.<p></font>"; 
print "<p>";
print "<font size=\"-1\"><center><a href=\"http://$httphost/$waspii_root/lists.htm\">Back to $title page</a></center></font><p>";

&sig; 
&bottom; 
}

#************************************** 
# 
# If nothing else, we display the form 
# 
#************************************** 

sub show{ 
&top("<font size=\"+2\"><b>$list_name</b></font><br>Subscribe or Unsubscribe<p>
<a href=\"mailto:$youremail\">Send e-mail to list admin</a>"); 

#
# check whether the admin lets web based subs and unsubs.
# if web based subs ans unsubs not allowed show notifications on the web page
#
$no_sub_msg = "";
$no_unsub_msg = "";

if ( $allow_web_subs eq "no") {
   $no_sub_msg =  "The admin of this list does not allow web subscriptions!";
   }
if ( $allow_web_unsubs eq "no") {
   $no_unsub_msg =  "The admin of this list does not allow web UnSubscriptions!";
   }

print qq~ 

<$font> 
<form action="http://$ENV{'HTTP_HOST'}/$cgi_url/$subscribe_name" method=GET> 
<input type=text size="40" name=email value="Please type your E-mail addr here"><p> 
<table>
<tr><td>Subscribe:</td><td><input type=radio name="a" value="subscribe" checked></td><td>$no_sub_msg</td></tr>
<tr><td>Unsubscribe:</td><td><input type=radio name="a" value="remove"></td><td>$no_unsub_msg</td></tr>
</table> 
<p>
<input type=submit value=" Go "> 
</form> 
</font> 

~; 

&sig; 
&bottom; 
exit; 
} 

#************************************** 
# 
# Here we check the email address, assign 
# an ID, make sure the email is unique 
# print the email to the confirmation 
# file and mail the person with 
# further instructions 

# 
#************************************** 

sub main{ 
my ($cid, $vid, $email, $n, $temp, @allkeys); 
#
# check whether web based subscription is allowed
#
if ( $allow_web_subs eq "no") {
  die &error($errmsg eq "Web based subscription is not allowed!");
}

# check email 
$email = $FORM{'email'}; 
$temp = $email; 
$temp =~ s/-/a/g; 
$temp =~ s/_/a/g; 
unless ($temp =~ /\w+@\w+\.\w\w+/) { 
        &error($errmsg = "Invalid Email: $email"); 
        } 

&top("$list_name - Subscription Information"); 
dbmopen(%CDB, "$db_data_path/confirm", 0600) or die &error($errmsg = "Unable to open $db_data_path/confirm"); 
dbmopen(%DB, "$db_data_path/emails", 0600) or die &error($errmsg = "Unable to open $db_data_path/emails"); 


# make sure the email is not already in the database 
@allkeys = keys(%DB); 


foreach $key(@allkeys){ 
my ($temail, $tday, $tmonth, $tyear) = split(/\t/, $DB{$key}); 
if ($temail eq $email){ 
          &error($errmsg = "The email $email already exists in the database"); 
          } 
} 

# select an ID and a confirmation ID 
$time = time; 
while(!$cid){ 
     $n = int(rand($time)); 
     unless ($CDB{$n} || $DB{$n}){ 
           $cid = $n; 
           $vid = int(rand($n)); 
     } 
} 
dbmclose(%DB); 

# add the record, if not successful we die 
my $info = "$vid"."\t"."$email"."\t"."$day"."\t"."$month"."\t"."$year"; 
unless($CDB{$cid} = $info){ 
      &error($errmsg = "Unable to add email to list"); 
      } 
dbmclose(%CDB); 

# mail the confirmation 
open(MAIL, "|$mailprogram -t"); 
print MAIL "From: $yourname <$youremail>\n"; 
print MAIL "Subject: Your subscription to $list_name\n"; 
print MAIL "X-Mailer: WASPII List Manager 3.0 \n"; 
print MAIL "Precedence: bulk\n"; 
print MAIL "To: $email\n\n"; 
print MAIL "Hello,\n\n"; 
print MAIL "Thank you requesting to be added to\n"; 
print MAIL "our mailing list, $list_name.\n\n"; 
print MAIL "Before we can add you to the list, however, we just\n"; 
print MAIL "need to verify that you really want to be on it.\n"; 
print MAIL "If it wasn't you who gave us your email address,\n"; 
print MAIL "just delete this email and you will not be added.\n"; 
print MAIL "Otherwise, simply point your browser to the URL:\n"; 
print MAIL "\n"; 
print MAIL "http://$ENV{'HTTP_HOST'}/$cgi_url/$confirm_name?cid=$cid&vid=$vid\n\n"; 
print MAIL "You must visit this page within 15 days, otherwise\n";
print MAIL "your subscription request will be cancelled.\n";
print MAIL "\n";
print MAIL "You can unsubscribe from this list any time you want\n";
print MAIL "using the simple forms at address:\n";
print MAIL "http://$ENV{'HTTP_HOST'}/$waspii_root/lists.htm\n";
print MAIL "\n";
print MAIL "\n";
print MAIL "Sincerely, \n$yourname\n"; 
print MAIL "$youremail\n"; 

close(MAIL); 


# give the output 
print "<$font>A confirmation message has been sent to <b>$email</b><p>"; 
print "You will need to follow instructions in that email<br>"; 
print " in order to begin receiving mailings from this list.<p></font>"; 
print "<p>";
print "<font size=\"-1\"><center><a href=\"http://$httphost/$waspii_root/lists.htm\">Back to $title page</a></center></font><p>";

&sig; 
&bottom; 
}

