#!/usr/bin/perl -U
# ------------- 
# Extensions to ASPII List Manager 
# ------------- 
# Email list manager / Batch subscription module
# 
# File: batchsubs.pl  
# Description:  Make Batch Subscribtions to the list 
# Author: Can Ugur Ayfer 
# Email: cayfer@bilkent.edu.tr 
# 
#===== usage : batchsubs -[n m] listname mail_addr ======================= 
#              -n : No Mail! Do not send subs info mail to added user
#              -m : Send subs info mail to added user
#              run this script in the directory 
#              i.e $htroot/cgi-bin/waspii/xxx of any list
#              Users can be auto susbcribed to any list from any
#              point in the lists hierarchy.

# path to config.pl 
require 'config.pl'; 
require "$subs_path"; 

# check if no of args OK
if (@ARGV ne 3) {
        die "Usage: batchsubs -[n m] listname emailaddr\n\n";
              }
# Check if the list (2nd arg) exists

opendir( LISTDIR, "../$ARGV[1]") || die "No directory for list $ARGV[1]\n";
closedir (LISTDIR);

# Check the appearance of the email address
$email = $ARGV[2];
$temp = $email;
$temp =~ s/-/a/g;   # get rid of any - so that \W in patt matching test works
$temp =~ s/_/a/g;   # get rid of any _ so that \W in patt matching test works
unless ( $temp =~ /\w+\@\w+\.\w\w+/) {die "Invalid email address $email\n"};

# list name and email addr OK. try to appe to db

dbmopen(%DB, "$db_data_path/emails", 0600) or die "Cannot open database file $db_data_path/emails\n";

# Make sure the user doen not already exist in db

@allkeys=keys(%DB);

foreach $key(@allkeys){
    my ($temail, $tday, $tmonth, $tyear) = split(/\t/, $DB{$key});
    if ($temail eq $email) {die "email address $email already exists!\n";}
                      }

#  everything OK. appe to db
while (!$cid){
      $n = int(rand(time));
      unless ($DB{$n}) {
             $cid = $n;
             }
}
my ($info) = "$email"."\t"."$day"."\t"."$month"."\t"."$year";
$DB{$cid} = $info;
dbmclose(%DB);


# If first arg was -m, we must send a notificaiton mail to user
print "$mailprogram  $email\n";
if ($ARGV[0] eq "-m") {
open(MAIL, "|$mailprogram -t");
print MAIL "From: $yourname <$youremail>\n";
print MAIL "Subject: Please confirm your subscription to $list_name\n";
print MAIL "X-Mailer: List Manager 2.0 \n";
print MAIL "Precedence: bulk\n";
print MAIL "To: $email\n\n";
print MAIL "Hello,\n\n";
print MAIL "Your e-mail address has been added to\n";
print MAIL "our mailing list, $list_name by $yourname of $title.\n\n";
print MAIL "Before we can actually add you to the list, however, we just\n";
print MAIL "need to verify that you really want to be on it.\n";
print MAIL "If it wasn't you who gave us your email address,\n";
print MAIL "just delete this email and you will not be added.\n";
print MAIL "Otherwise, simply point your browser to the URL:\n";
print MAIL "\n";
print MAIL "http://$ENV{'HTTP_HOST'}/$cgi_url/$confirm_name?cid=$cid&vid=$vid\n\
n";
print MAIL "Please note that once you go to the page above,\n";
print MAIL "we shall assume that you want to confirm. In other\n";
print MAIL "words, a visit to this page will confirm your \n";
print MAIL "subscription. No buttons, no clicks!\n";
print MAIL "You must visit this page within 15 days, otherwise\n"; 
print MAIL "your subscription request will be cancelled.\n";
print MAIL "\n";
print MAIL "You can unsubscribe from this list any time you want\n";
print MAIL "using the simple forms at address:\n";
print MAIL "http://$ENV{'HTTP_HOST'}/$waspii_root/lists.htm\n";
print MAIL "\n";
print MAIL "\n";
print MAIL "Sincerely, \n$yourname\n";
print MAIL "$youremail\n";

close(MAIL);
}

