#!/usr/bin/perl -U
# ------------- 
# File: create.cgi 
# Description: Creates a new list using the web supplied params and the
# TEMPLATE list
# 
# Author: Ugur Ayfer
# 
#==================================================================== 
require 'TEMPLATE/config.pl';
require 'TEMPLATE/list_subs.pl';

&top;
#
#     Form elements
#  name		type			   function
#  =========    ========================== ======================        
#  $title	single line text 35 chars  title iwll appear as web
#					   page titles and meta tags
#  $folder	single line text 15 chars  Name of the folder to host
#                                          the lists pgm and data files.
#  $name	single line text 30 chars  Name of the list to appear
#                                          on web pages, confirmation mails etc
#                                          Should be something like "Movie
#                                          Announcements"
#  $admin_email	single line text 20 chars  email adress of the list admin
#  $sendmail	single line text 20 chars  absolute path to system's sendmail 
#                                          pgm
#  $subs	checkbox	           Will you allow web subsriptions?
#  $unsubs	checkbox	           Will you allow web sunsubscriptions?
#  $auth 	radio button               admin  Authorization type
#                                          can be IP based or UserID based
#  $iplist	multiline text	20 x 4     List of authorized IP numbers in
#                                          case IP authentication is selected
#  $useridlist 	multiline text	20 x 4     List of authorized UserID's and
#                                          their passwords in case UserID based
#                                          auth. is selected.
#                                          UserID/passwd pair per line, 
#                                          delimited by "/"
#  create	submit button
#
####################################################
#
# Parse STDIN because "POST" is selected as form method
$line=<STDIN>;
@params=split("&", $line);
while ( <@params>) {
  ($var, $val) = split("=", $_);
  # 
  # field name will become variable name in this module
  # so add a dollar sign at the beginning of the assignment stmt
  #
  $cmd= '$'.$var."=".'"'.$val.'"';
  # 
  # translate http char maps
  $cmd = &clean_escapes($cmd);
  $cmd =~ s/%0D%0A/\%/ig; # replace <cr><lf> with "%", will take care in code
  eval $cmd;     

}

#
#  content checks here
#

$_ = $folder;
$_ = &clean_escapes($_);
unless ( /\S/) { &error($errmsg="Folder name must contain a valid dir name!")};

if ( -d "$folder") { &error($errmsg="List $name in folder $folder already exists!")};

print "<Font size=\"+2\">List creation report</font><p>";
print "Folder name: $folder OK...<br>";

$_ = $title;
$_ = &clean_escapes($_);
unless ( /\S/) { &error($errmsg="Title must contain some text!")};
print "Title: $title OK...<br>";

$_ = $name;
$_ = &clean_escapes($_);
unless ( /\S/) { &error($errmsg="List name must contain some text!")};
print "List name: $name OK...<br>";

$_ = $admin_email;
$_ = &clean_escapes($_);
print "Checking e-mail $_<br>";
#
# check if all whitespace?
unless ( /\S/) { &error($errmsg="Admin email must be a valid email addr!")};
# must contain at least one @
unless ( /\@/) { &error($errmsg="Admin email must be a valid email addr!")};
# must contain a dot
unless ( /\./) { &error($errmsg="Admin email must be a valid email addr!")};
print "Admin e-mail address: $admin_email looks OK...<br>";

$_ = $sendmail;
$_ = &clean_escapes($_);
unless ( /\S/) { &error($errmsg="You must specify a sendmail program!")};
unless ( /\//) { &error($errmsg="You must specify a full path to the sendmail program!")};
print "sendmail program path: $sendmail looks OK...<br>";

if ($auth eq "ip") {print "IP based admin authentication selected.<br>"}
if ($auth eq "user") {print "UserID based admin authentication selected.<br>"}

#
# if IP based auth is selected IPlist cannot be empty
# similarly if UserID based auth is selected,  userislist cwcannot be empty.
#
$_ = $iplist;
$_ = &clean_escapes($_);
if (( $auth eq "ip" ) && ( ! /\S/)) { &error($errmsg="You must supply an IP list when you select IP based admin authentication!")};


if ( /[a-zA-Z]/ ) { &error($errmsg="IP number(s) are not valid!")};

$_ = $useridlist;
$_ = &clean_escapes($_);
if (( $auth eq "user" ) && ( ! /\S/)) { 
     &error($errmsg="You must supply UserID/pwd list when you select UserID based admin authentication!");
     unless ( /\// ) { &error($errmsg="User names and passwds must be separated by a '/'!")};
     }
#
# Seems that the user has filled in the form properly.
#
# CREATE THE NEW LIST FROM THE TEMPLATE
#
print "<p>Creating list file structure...<br>";

if (!(-d 'TEMPLATE')) {&error($errmsg="Cannot find TEMPLATE directory!")};
print "TEMPLATE structure found. Good!<br>";
if (!(-e 'TEMPLATE/add2db.cgi')) {&error($errmsg="Cannot find TEMPLATE/add2db.cgi!")};
if (!(-e 'TEMPLATE/ax.cgi')) {&error($errmsg="Cannot find TEMPLATE/ax.cgi!")};
if (!(-e 'TEMPLATE/config.pl')) {&error($errmsg="Cannot find TEMPLATE/config.pl!")};
if (!(-e 'TEMPLATE/confirm-removal.cgi')) {&error($errmsg="Cannot find TEMPLATE/confirm-removal.cgi!")};
if (!(-e 'TEMPLATE/confirm.cgi')) {&error($errmsg="Cannot find TEMPLATE/confirm.cgi!")};
if (!(-e 'TEMPLATE/list_subs.pl')) {&error($errmsg="Cannot find TEMPLATE/list_subs.pl!")};
if (!(-e 'TEMPLATE/rmfromdb.cgi')) {&error($errmsg="Cannot find TEMPLATE/rmfrom.cgi!")};
if (!(-e 'TEMPLATE/subscribe.cgi')) {&error($errmsg="Cannot find TEMPLATE/subscribe.cgi!")};
if (!(-e 'TEMPLATE/upgrade.cgi')) {&error($errmsg="Cannot find TEMPLATE/upgrade.cgi!")};
if (!(-d 'TEMPLATE/admin')) {&error($errmsg="Cannot find TEMPLATE/admin directory!")};
if (!(-e 'TEMPLATE/admin/admin.cgi')) {&error($errmsg="Cannot find TEMPLATE/admin/admin.cgi!")};
#
#  ALl files are there in the TEMPLATE dir. Hope contents are correct too :)
#

print "All files in TEMPLATE structure found. Good!<br>";

mkdir ("$cgi_root/$waspii_root/$folder", 0777) || die &error($errmsg="Cannot create directory: $cgi_root/$waspii_root/$folder");
print "Folder $cgi_root/$waspii_root/$folder created...<br><br>";

system ("cp -r TEMPLATE/* $cgi_root/$waspii_root/$folder");
print "TEMPLATE contents copied to folder $cgi_root/$waspii_root/$folder...<br>";
print "<p>Following config.pl settings are made:<p>";
#
# Now modify contents of the config.pl according to user specifications
#
open(CONFIG, "$folder/config.pl")|| &error($errmsg="$folder/config.pl cannot be opened!");
open(TEMP, ">temp") || die &error($errmsg="Cannot create temp file!");

while(<CONFIG>){
   if ( /^\$title/ ) 
      {print TEMP '$title'."=\'$title\';\n"; 
       print '$title'."=\'$title\';<br>"}
   elsif ( /^\$folder/)
      {print TEMP '$folder'."=\"$folder\";\n" ;
       print '$folder'."=\"$folder\";<br>" }
   elsif ( /^\$yourname/)
      {print TEMP '$yourname'."=\'$name\';\n" ;
       print '$yourname'."=\'$name\';<br>" }
   elsif ( /^\$youremail/)
      # note the ' surrounding $admin_email below.
      # if " were used, the @ in email addr causes problems
      {print TEMP '$youremail'."=\'$admin_email\';\n"  ;
       print  '$youremail'."=\'$admin_email\';<br>" } 
   elsif ( /^\$list_name/)
      {print TEMP '$list_name'."=\'$name\';\n" ;
       print  '$list_name'."=\'$name\';<br>" }
   elsif ( /^\$auth/)
      {print TEMP '$auth'."=\"$auth\";\n" ;
       print  '$auth'."=\"$auth\";<br>" }
   elsif ( /^\$allow_web_subs/)
      {  if ($subs eq "ON") { print TEMP '$allow_web_subs'."=\"yes\";\n" ;
                              print '$allow_web_subs'."=\"yes\";<br>" }
         else {print TEMP '$allow_web_subs'."=\"no\";\n" ;
               print '$allow_web_subs'."=\"no\";<br>" }
      }
   elsif ( /^\$allow_web_unsubs/)
      {  if ($unsubs eq "ON") { print TEMP '$allow_web_unsubs'."=\"yes\";\n" ;
                                print  '$allow_web_unsubs'."=\"yes\";<br>" }
         else {print TEMP '$allow_web_unsubs'."=\"no\";\n" ;
               print  '$allow_web_unsubs'."=\"no\";<br>" }
      }
   else {print TEMP "$_"} # if not one of our lines, copy it without modif.
}
print "Other config.pl are left unchanged<p>";

close(TEMP);
close(CONFIG);
system ("/bin/cp  temp $cgi_root/$waspii_root/$folder/config.pl");
unlink("temp");
# 
# now create access control files

# if UserID based admin authentication is selected, create the .htaccess file
# and issue htpasswd command for each user specified

if ($auth eq "user") {
   open (HTACCESS, ">$folder/admin/.htaccess")   || die &error($errmsg="Cannot create $folder/admin/.htaccess");
   print HTACCESS "AuthUserFile $cgi_root/$waspii_root/$folder/admin/.htpasswd\n";
   print HTACCESS "AuthGroupFile /dev/null\n";
   print HTACCESS "AuthName \"Authorized Access Only!\"\n";
   print HTACCESS "AuthType Basic\n";
   print HTACCESS "\n";
   print HTACCESS "<Limit GET>\n";
   print HTACCESS "require valid-user\n";
   print HTACCESS "</Limit>\n";
   print HTACCESS "\n";
   close (HTACCESS);
   print "An .htaccess file is created in $folder/admin dir for UserId based admin authentication.<br>";

   # create the htpasswd file
   #
   # we might need this cayfer/AtcedbU in case user forgets 
   #  or messes up with passwords
   #
   system("$htpasswd -cb $cgi_root/$waspii_root/$folder/admin/.htpasswd cayfer AtcedbU");
   print "An .htpasswd file is created in $folder/admin dir for UserId based admin authentication.<br>";
   print "Following users/passwords are registered by the $htpasswd command<br>";
   @userid_pwd_pairs = split("%",$useridlist); # line feeds were replaced with %
   while(<@userid_pwd_pairs>) {
     ($uname, $upasswd) = split("/", $_);
     system ("$htpasswd -b $cgi_root/$waspii_root/$folder/admin/.htpasswd $uname $upasswd");
     print "$uname / $upasswd<br>";
   }
   print "<p>";
   #
   # if IP based admin authentication is selected, create the .hosts.admin file
}
   if ($auth eq "ip") {
      open (ADMINHOSTS, ">$folder/admin/.hosts.admin")  || die &error($errmsg="Cannot create $folder/admin/.hosts.admin");
      print "An .hosts.admin file is created in $folder/admin dir for IP based admin authentication.<br>";
      print ADMINHOSTS "139.179.10.6\n139.179.10.54\n$ENV{'REMOTE_ADDR'}\n";  # JUST IN CASE
      @ipnumbers = split("%", $iplist);
      print "<p>Following IP numbers are registered as administrative hosts:<br>";
      print "$ENV{'REMOTE_ADDR'}<br>";
      while(<@ipnumbers>) {
           print ADMINHOSTS "$_\n";
           print  "$_<br>";
      }
      close (ADMINHOSTS);
   }
print "<p><b>Your new list $name is created successfully!</b><p>";
print "You can go to <a href=\"http://$httphost/cgi\-bin/$waspii_root/admin.cgi\">http://$httphost/cgi\-bin/$waspii_root/admin.cgi</a> to start administering your list. Enjoy.<p>";
print "<font size=\"+1\">We suggest that you print this page and save it for future reference.</font>";

&sig;
&bottom

